/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* TypeDef Declarations                                                       *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_TYPEDEF_CLASSES
#undef GET_TYPEDEF_CLASSES


namespace mlir {
class AsmParser;
class AsmPrinter;
} // namespace mlir
namespace test {
class CompoundNestedInnerType;
class CompoundNestedOuterType;
class CompoundNestedOuterQualType;
class CompoundAType;
class TestIntegerType;
class SimpleAType;
class StructType;
class TestMemRefElementTypeType;
class TestType;
class TestTypeNoParserType;
class TestStructTypeCaptureAllType;
class TestTypeWithFormatType;
class TestTypeWithLayoutType;
class TestTypeWithTraitType;
namespace detail {
struct CompoundNestedInnerTypeStorage;
} // namespace detail
class CompoundNestedInnerType : public ::mlir::Type::TypeBase<CompoundNestedInnerType, ::mlir::Type, detail::CompoundNestedInnerTypeStorage> {
public:
  using Base::Base;
public:
  static CompoundNestedInnerType get(::mlir::MLIRContext *context, int some_int, ::test::CompoundAType cmpdA);
  static constexpr ::llvm::StringLiteral getMnemonic() {
    return {"cmpnd_inner"};
  }

  static ::mlir::Type parse(::mlir::AsmParser &parser);
  void print(::mlir::AsmPrinter &printer) const;
  int getSome_int() const;
  ::test::CompoundAType getCmpdA() const;
};
namespace detail {
struct CompoundNestedOuterTypeStorage;
} // namespace detail
class CompoundNestedOuterType : public ::mlir::Type::TypeBase<CompoundNestedOuterType, ::mlir::Type, detail::CompoundNestedOuterTypeStorage> {
public:
  using Base::Base;
public:
  static CompoundNestedOuterType get(::mlir::MLIRContext *context, ::test::CompoundNestedInnerType inner);
  static constexpr ::llvm::StringLiteral getMnemonic() {
    return {"cmpnd_nested_outer"};
  }

  static ::mlir::Type parse(::mlir::AsmParser &parser);
  void print(::mlir::AsmPrinter &printer) const;
  ::test::CompoundNestedInnerType getInner() const;
};
namespace detail {
struct CompoundNestedOuterQualTypeStorage;
} // namespace detail
class CompoundNestedOuterQualType : public ::mlir::Type::TypeBase<CompoundNestedOuterQualType, ::mlir::Type, detail::CompoundNestedOuterQualTypeStorage> {
public:
  using Base::Base;
public:
  static CompoundNestedOuterQualType get(::mlir::MLIRContext *context, ::test::CompoundNestedInnerType inner);
  static constexpr ::llvm::StringLiteral getMnemonic() {
    return {"cmpnd_nested_outer_qual"};
  }

  static ::mlir::Type parse(::mlir::AsmParser &parser);
  void print(::mlir::AsmPrinter &printer) const;
  ::test::CompoundNestedInnerType getInner() const;
};
namespace detail {
struct CompoundATypeStorage;
} // namespace detail
class CompoundAType : public ::mlir::Type::TypeBase<CompoundAType, ::mlir::Type, detail::CompoundATypeStorage> {
public:
  using Base::Base;
  struct SomeCppStruct {};
public:
  static CompoundAType get(::mlir::MLIRContext *context, int widthOfSomething, ::mlir::Type oneType, ::llvm::ArrayRef<int> arrayOfInts);
  static constexpr ::llvm::StringLiteral getMnemonic() {
    return {"cmpnd_a"};
  }

  static ::mlir::Type parse(::mlir::AsmParser &parser);
  void print(::mlir::AsmPrinter &printer) const;
  int getWidthOfSomething() const;
  ::mlir::Type getOneType() const;
  ::llvm::ArrayRef<int> getArrayOfInts() const;
};
namespace detail {
struct TestIntegerTypeStorage;
} // namespace detail
class TestIntegerType : public ::mlir::Type::TypeBase<TestIntegerType, ::mlir::Type, detail::TestIntegerTypeStorage> {
public:
  using Base::Base;
  /// Signedness semantics.
  enum SignednessSemantics {
    Signless, /// No signedness semantics
    Signed,   /// Signed integer
    Unsigned, /// Unsigned integer
  };

  /// Return true if this is a signless integer type.
  bool isSignless() const { return getSignedness() == Signless; }
  /// Return true if this is a signed integer type.
  bool isSigned() const { return getSignedness() == Signed; }
  /// Return true if this is an unsigned integer type.
  bool isUnsigned() const { return getSignedness() == Unsigned; }
  using Base::getChecked;
public:
  static TestIntegerType get(::mlir::MLIRContext *context, unsigned width, SignednessSemantics signedness = Signless);
  static TestIntegerType getChecked(::llvm::function_ref<::mlir::InFlightDiagnostic()> emitError, ::mlir::MLIRContext *context, unsigned width, SignednessSemantics signedness = Signless);
  static ::mlir::LogicalResult verify(::llvm::function_ref<::mlir::InFlightDiagnostic()> emitError, unsigned width, ::test::TestIntegerType::SignednessSemantics signedness);
  static constexpr ::llvm::StringLiteral getMnemonic() {
    return {"int"};
  }

  static ::mlir::Type parse(::mlir::AsmParser &parser);
  void print(::mlir::AsmPrinter &printer) const;
  unsigned getWidth() const;
  ::test::TestIntegerType::SignednessSemantics getSignedness() const;
};
class SimpleAType : public ::mlir::Type::TypeBase<SimpleAType, ::mlir::Type, ::mlir::TypeStorage> {
public:
  using Base::Base;
public:
  static constexpr ::llvm::StringLiteral getMnemonic() {
    return {"smpla"};
  }

};
namespace detail {
struct StructTypeStorage;
} // namespace detail
class StructType : public ::mlir::Type::TypeBase<StructType, ::mlir::Type, detail::StructTypeStorage> {
public:
  using Base::Base;
public:
  static StructType get(::mlir::MLIRContext *context, ::llvm::ArrayRef<::test::FieldInfo> fields);
  static constexpr ::llvm::StringLiteral getMnemonic() {
    return {"struct"};
  }

  static ::mlir::Type parse(::mlir::AsmParser &parser);
  void print(::mlir::AsmPrinter &printer) const;
  ::llvm::ArrayRef<::test::FieldInfo> getFields() const;
};
class TestMemRefElementTypeType : public ::mlir::Type::TypeBase<TestMemRefElementTypeType, ::mlir::Type, ::mlir::TypeStorage, ::mlir::MemRefElementTypeInterface::Trait> {
public:
  using Base::Base;
public:
  static constexpr ::llvm::StringLiteral getMnemonic() {
    return {"memref_element"};
  }

};
class TestType : public ::mlir::Type::TypeBase<TestType, ::mlir::Type, ::mlir::TypeStorage, ::test::TestTypeInterface::Trait> {
public:
  using Base::Base;
public:
  static constexpr ::llvm::StringLiteral getMnemonic() {
    return {"test_type"};
  }

  void printTypeC(::mlir::Location loc) const;
};
namespace detail {
struct TestTypeNoParserTypeStorage;
} // namespace detail
class TestTypeNoParserType : public ::mlir::Type::TypeBase<TestTypeNoParserType, ::mlir::Type, detail::TestTypeNoParserTypeStorage> {
public:
  using Base::Base;
public:
  static TestTypeNoParserType get(::mlir::MLIRContext *context, uint32_t one, ::llvm::ArrayRef<int64_t> two, ::llvm::StringRef three, ::test::CustomParam four);
  static constexpr ::llvm::StringLiteral getMnemonic() {
    return {"no_parser"};
  }

  static ::mlir::Type parse(::mlir::AsmParser &parser);
  void print(::mlir::AsmPrinter &printer) const;
  uint32_t getOne() const;
  ::llvm::ArrayRef<int64_t> getTwo() const;
  ::llvm::StringRef getThree() const;
  ::test::CustomParam getFour() const;
};
namespace detail {
struct TestStructTypeCaptureAllTypeStorage;
} // namespace detail
class TestStructTypeCaptureAllType : public ::mlir::Type::TypeBase<TestStructTypeCaptureAllType, ::mlir::Type, detail::TestStructTypeCaptureAllTypeStorage> {
public:
  using Base::Base;
public:
  static TestStructTypeCaptureAllType get(::mlir::MLIRContext *context, int v0, int v1, int v2, int v3);
  static constexpr ::llvm::StringLiteral getMnemonic() {
    return {"struct_capture_all"};
  }

  static ::mlir::Type parse(::mlir::AsmParser &parser);
  void print(::mlir::AsmPrinter &printer) const;
  int getV0() const;
  int getV1() const;
  int getV2() const;
  int getV3() const;
};
namespace detail {
struct TestTypeWithFormatTypeStorage;
} // namespace detail
class TestTypeWithFormatType : public ::mlir::Type::TypeBase<TestTypeWithFormatType, ::mlir::Type, detail::TestTypeWithFormatTypeStorage> {
public:
  using Base::Base;
public:
  static TestTypeWithFormatType get(::mlir::MLIRContext *context, int64_t one, std::string two, ::mlir::Attribute three);
  static constexpr ::llvm::StringLiteral getMnemonic() {
    return {"type_with_format"};
  }

  static ::mlir::Type parse(::mlir::AsmParser &parser);
  void print(::mlir::AsmPrinter &printer) const;
  int64_t getOne() const;
  llvm::StringRef getTwo() const;
  ::mlir::Attribute getThree() const;
};
namespace detail {
struct TestTypeWithLayoutTypeStorage;
} // namespace detail
class TestTypeWithLayoutType : public ::mlir::Type::TypeBase<TestTypeWithLayoutType, ::mlir::Type, detail::TestTypeWithLayoutTypeStorage, ::mlir::DataLayoutTypeInterface::Trait> {
public:
  using Base::Base;
    ::mlir::LogicalResult verifyEntries(::mlir::DataLayoutEntryListRef params,
                                ::mlir::Location loc) const;

  private:
    unsigned extractKind(::mlir::DataLayoutEntryListRef params,
                         ::llvm::StringRef expectedKind) const;

  public:
public:
  static TestTypeWithLayoutType get(::mlir::MLIRContext *context, unsigned key);
  static constexpr ::llvm::StringLiteral getMnemonic() {
    return {"test_type_with_layout"};
  }

  static ::mlir::Type parse(::mlir::AsmParser &parser);
  void print(::mlir::AsmPrinter &printer) const;
  unsigned getKey() const;
  unsigned getTypeSizeInBits(const ::mlir::DataLayout &dataLayout, ::mlir::DataLayoutEntryListRef params) const;
  unsigned getABIAlignment(const ::mlir::DataLayout &dataLayout, ::mlir::DataLayoutEntryListRef params) const;
  unsigned getPreferredAlignment(const ::mlir::DataLayout &dataLayout, ::mlir::DataLayoutEntryListRef params) const;
  bool areCompatible(::mlir::DataLayoutEntryListRef oldLayout, ::mlir::DataLayoutEntryListRef newLayout) const;
};
class TestTypeWithTraitType : public ::mlir::Type::TypeBase<TestTypeWithTraitType, ::mlir::Type, ::mlir::TypeStorage, ::mlir::TypeTrait::TestTypeTrait> {
public:
  using Base::Base;
public:
  static constexpr ::llvm::StringLiteral getMnemonic() {
    return {"test_type_with_trait"};
  }

};
} // namespace test
DECLARE_EXPLICIT_TYPE_ID(::test::CompoundNestedInnerType)
DECLARE_EXPLICIT_TYPE_ID(::test::CompoundNestedOuterType)
DECLARE_EXPLICIT_TYPE_ID(::test::CompoundNestedOuterQualType)
DECLARE_EXPLICIT_TYPE_ID(::test::CompoundAType)
DECLARE_EXPLICIT_TYPE_ID(::test::TestIntegerType)
DECLARE_EXPLICIT_TYPE_ID(::test::SimpleAType)
DECLARE_EXPLICIT_TYPE_ID(::test::StructType)
DECLARE_EXPLICIT_TYPE_ID(::test::TestMemRefElementTypeType)
DECLARE_EXPLICIT_TYPE_ID(::test::TestType)
DECLARE_EXPLICIT_TYPE_ID(::test::TestTypeNoParserType)
DECLARE_EXPLICIT_TYPE_ID(::test::TestStructTypeCaptureAllType)
DECLARE_EXPLICIT_TYPE_ID(::test::TestTypeWithFormatType)
DECLARE_EXPLICIT_TYPE_ID(::test::TestTypeWithLayoutType)
DECLARE_EXPLICIT_TYPE_ID(::test::TestTypeWithTraitType)

#endif  // GET_TYPEDEF_CLASSES

